Index: trunk/quest-core-tasktrees-test/src/test/java/de/ugoe/cs/quest/tasktrees/temporalrelation/DefaultTextInputReductionRuleTest.java
===================================================================
--- trunk/quest-core-tasktrees-test/src/test/java/de/ugoe/cs/quest/tasktrees/temporalrelation/DefaultTextInputReductionRuleTest.java	(revision 468)
+++ trunk/quest-core-tasktrees-test/src/test/java/de/ugoe/cs/quest/tasktrees/temporalrelation/DefaultTextInputReductionRuleTest.java	(revision 557)
@@ -25,387 +23,371 @@
  * @author 2012, last modified by $Author: patrick$
  */
-//-------------------------------------------------------------------------------------------------
-public class DefaultTextInputReductionRuleTest extends AbstractTemporalRelationshipTC
-{
-
-  //-----------------------------------------------------------------------------------------------
-  /**
-   *
-   */
-  //-----------------------------------------------------------------------------------------------
-  @Test
-  public void testSimpleTextEntry()
-  {
-    GUIElement element1 = new DummyTextField("elem1");
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_A));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_A));
-    new TaskTreeChecker(true).assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput a {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_B));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_B));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput ab {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput abC {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_C {}" +
-       "    Interaction KeyReleased LETTER_C {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_D));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_D));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_E));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_E));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_F));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_F));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput abCDEF {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_C {}" +
-       "    Interaction KeyReleased LETTER_C {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_D {}" +
-       "    Interaction KeyReleased LETTER_D {}" +
-       "    Interaction KeyPressed LETTER_E {}" +
-       "    Interaction KeyReleased LETTER_E {}" +
-       "    Interaction KeyPressed LETTER_F {}" +
-       "    Interaction KeyReleased LETTER_F {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_G));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_G));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput abCDEFg {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_C {}" +
-       "    Interaction KeyReleased LETTER_C {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_D {}" +
-       "    Interaction KeyReleased LETTER_D {}" +
-       "    Interaction KeyPressed LETTER_E {}" +
-       "    Interaction KeyReleased LETTER_E {}" +
-       "    Interaction KeyPressed LETTER_F {}" +
-       "    Interaction KeyReleased LETTER_F {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed SHIFT {}" +
-       "    Interaction KeyPressed LETTER_G {}" +
-       "    Interaction KeyReleased LETTER_G {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "    Interaction KeyReleased SHIFT {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-  }
-  
-  //-----------------------------------------------------------------------------------------------
-  /**
-   *
-   */
-  //-----------------------------------------------------------------------------------------------
-  @Test
-  public void testTextEntryOnDifferentGuiElements()
-  {
-    GUIElement element1 = new DummyTextField("elem1");
-    GUIElement element2 = new DummyTextField("elem2");
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_A));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_A));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput a {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element2, new KeyPressed(VirtualKey.LETTER_B));
-    simulateInteraction(element2, new KeyReleased(VirtualKey.LETTER_B));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  Sequence sequence1 {" +
-       "    TextInputInteraction TextInput a {" +
-       "      Interaction KeyPressed LETTER_A {}" +
-       "      Interaction KeyReleased LETTER_A {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence2 {" +
-       "    TextInputInteraction TextInput b {" +
-       "      Interaction KeyPressed LETTER_B {}" +
-       "      Interaction KeyReleased LETTER_B {}" +
-       "    }" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  Sequence sequence1 {" +
-       "    TextInputInteraction TextInput a {" +
-       "      Interaction KeyPressed LETTER_A {}" +
-       "      Interaction KeyReleased LETTER_A {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence2 {" +
-       "    TextInputInteraction TextInput b {" +
-       "      Interaction KeyPressed LETTER_B {}" +
-       "      Interaction KeyReleased LETTER_B {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence3 {" +
-       "    TextInputInteraction TextInput C {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_C {}" +
-       "      Interaction KeyReleased LETTER_C {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element2, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element2, new KeyPressed(VirtualKey.LETTER_D));
-    simulateInteraction(element2, new KeyReleased(VirtualKey.LETTER_D));
-    simulateInteraction(element2, new KeyPressed(VirtualKey.LETTER_E));
-    simulateInteraction(element2, new KeyReleased(VirtualKey.LETTER_E));
-    simulateInteraction(element2, new KeyPressed(VirtualKey.LETTER_F));
-    simulateInteraction(element2, new KeyReleased(VirtualKey.LETTER_F));
-    simulateInteraction(element2, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  Sequence sequence1 {" +
-       "    TextInputInteraction TextInput a {" +
-       "      Interaction KeyPressed LETTER_A {}" +
-       "      Interaction KeyReleased LETTER_A {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence2 {" +
-       "    TextInputInteraction TextInput b {" +
-       "      Interaction KeyPressed LETTER_B {}" +
-       "      Interaction KeyReleased LETTER_B {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence3 {" +
-       "    TextInputInteraction TextInput C {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_C {}" +
-       "      Interaction KeyReleased LETTER_C {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence4 {" +
-       "    TextInputInteraction TextInput DEF {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_D {}" +
-       "      Interaction KeyReleased LETTER_D {}" +
-       "      Interaction KeyPressed LETTER_E {}" +
-       "      Interaction KeyReleased LETTER_E {}" +
-       "      Interaction KeyPressed LETTER_F {}" +
-       "      Interaction KeyReleased LETTER_F {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "}", getTaskTree());    
-
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_G));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_G));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.SHIFT));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  Sequence sequence1 {" +
-       "    TextInputInteraction TextInput a {" +
-       "      Interaction KeyPressed LETTER_A {}" +
-       "      Interaction KeyReleased LETTER_A {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence2 {" +
-       "    TextInputInteraction TextInput b {" +
-       "      Interaction KeyPressed LETTER_B {}" +
-       "      Interaction KeyReleased LETTER_B {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence3 {" +
-       "    TextInputInteraction TextInput C {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_C {}" +
-       "      Interaction KeyReleased LETTER_C {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence4 {" +
-       "    TextInputInteraction TextInput DEF {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_D {}" +
-       "      Interaction KeyReleased LETTER_D {}" +
-       "      Interaction KeyPressed LETTER_E {}" +
-       "      Interaction KeyReleased LETTER_E {}" +
-       "      Interaction KeyPressed LETTER_F {}" +
-       "      Interaction KeyReleased LETTER_F {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "  Sequence sequence5 {" +
-       "    TextInputInteraction TextInput g {" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed SHIFT {}" +
-       "      Interaction KeyPressed LETTER_G {}" +
-       "      Interaction KeyReleased LETTER_G {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "      Interaction KeyReleased SHIFT {}" +
-       "    }" +
-       "  }" +
-       "}", getTaskTree());    
-
-  }
-  
-  //-----------------------------------------------------------------------------------------------
-  /**
-   *
-   */
-  //-----------------------------------------------------------------------------------------------
-  @Test
-  public void testUsageOfBackspace()
-  {
-    GUIElement element1 = new DummyTextField("elem1");
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_A));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_A));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_B));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_B));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_C));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_D));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_D));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_E));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_E));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.LETTER_F));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.LETTER_F));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput abcef {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "    Interaction KeyPressed LETTER_C {}" +
-       "    Interaction KeyReleased LETTER_C {}" +
-       "    Interaction KeyPressed LETTER_D {}" +
-       "    Interaction KeyReleased LETTER_D {}" +
-       "    Interaction KeyPressed BACK_SPACE {}" +
-       "    Interaction KeyReleased BACK_SPACE {}" +
-       "    Interaction KeyPressed LETTER_E {}" +
-       "    Interaction KeyReleased LETTER_E {}" +
-       "    Interaction KeyPressed LETTER_F {}" +
-       "    Interaction KeyReleased LETTER_F {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-    simulateInteraction(element1, new KeyPressed(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyPressed(VirtualKey.BACK_SPACE));
-    simulateInteraction(element1, new KeyReleased(VirtualKey.BACK_SPACE));
-    new TaskTreeChecker().assertTaskTree
-      ("Sequence sequence0 {" +
-       "  TextInputInteraction TextInput ab {" +
-       "    Interaction KeyPressed LETTER_A {}" +
-       "    Interaction KeyReleased LETTER_A {}" +
-       "    Interaction KeyPressed LETTER_B {}" +
-       "    Interaction KeyReleased LETTER_B {}" +
-       "    Interaction KeyPressed LETTER_C {}" +
-       "    Interaction KeyReleased LETTER_C {}" +
-       "    Interaction KeyPressed LETTER_D {}" +
-       "    Interaction KeyReleased LETTER_D {}" +
-       "    Interaction KeyPressed BACK_SPACE {}" +
-       "    Interaction KeyReleased BACK_SPACE {}" +
-       "    Interaction KeyPressed LETTER_E {}" +
-       "    Interaction KeyReleased LETTER_E {}" +
-       "    Interaction KeyPressed LETTER_F {}" +
-       "    Interaction KeyReleased LETTER_F {}" +
-       "    Interaction KeyPressed BACK_SPACE {}" +
-       "    Interaction KeyReleased BACK_SPACE {}" +
-       "    Interaction KeyPressed BACK_SPACE {}" +
-       "    Interaction KeyReleased BACK_SPACE {}" +
-       "    Interaction KeyPressed BACK_SPACE {}" +
-       "    Interaction KeyReleased BACK_SPACE {}" +
-       "  }" +
-       "}", getTaskTree());    
-
-  }
-  
-  //-----------------------------------------------------------------------------------------------
-  /**
-   *
-   */
-  //-----------------------------------------------------------------------------------------------
-  private static class DummyTextField extends DummyGUIElement implements TextField
-  {
-
-    //---------------------------------------------------------------------------------------------
+public class DefaultTextInputReductionRuleTest extends AbstractTemporalRelationshipTC {
+
     /**
-     * TODO: comment
      *
-     * @param name
      */
-    //---------------------------------------------------------------------------------------------
-    public DummyTextField(String name)
-    {
-      super(name);
+    @Test
+    public void testSimpleTextEntry() {
+        IGUIElement element1 = new DummyTextField("elem1");
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_A), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_A), element1);
+        new TaskTreeChecker(true).assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput a {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_B), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_B), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput ab {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput abC {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_C {}" +
+             "    Event KeyReleased LETTER_C {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_D), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_D), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_E), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_E), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_F), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_F), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput abCDEF {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_C {}" +
+             "    Event KeyReleased LETTER_C {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_D {}" +
+             "    Event KeyReleased LETTER_D {}" +
+             "    Event KeyPressed LETTER_E {}" +
+             "    Event KeyReleased LETTER_E {}" +
+             "    Event KeyPressed LETTER_F {}" +
+             "    Event KeyReleased LETTER_F {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_G), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_G), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput abCDEFg {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_C {}" +
+             "    Event KeyReleased LETTER_C {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_D {}" +
+             "    Event KeyReleased LETTER_D {}" +
+             "    Event KeyPressed LETTER_E {}" +
+             "    Event KeyReleased LETTER_E {}" +
+             "    Event KeyPressed LETTER_F {}" +
+             "    Event KeyReleased LETTER_F {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed SHIFT {}" +
+             "    Event KeyPressed LETTER_G {}" +
+             "    Event KeyReleased LETTER_G {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "    Event KeyReleased SHIFT {}" +
+             "  }" +
+             "}", getTaskTree());
+
     }
 
-  }
+    /**
+     *
+     */
+    @Test
+    public void testTextEntryOnDifferentGuiElements() {
+        IGUIElement element1 = new DummyTextField("elem1");
+        IGUIElement element2 = new DummyTextField("elem2");
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_A), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_A), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput a {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_B), element2);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_B), element2);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  Sequence sequence1 {" +
+             "    TextInputEvent TextInput a {" +
+             "      Event KeyPressed LETTER_A {}" +
+             "      Event KeyReleased LETTER_A {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence2 {" +
+             "    TextInputEvent TextInput b {" +
+             "      Event KeyPressed LETTER_B {}" +
+             "      Event KeyReleased LETTER_B {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  Sequence sequence1 {" +
+             "    TextInputEvent TextInput a {" +
+             "      Event KeyPressed LETTER_A {}" +
+             "      Event KeyReleased LETTER_A {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence2 {" +
+             "    TextInputEvent TextInput b {" +
+             "      Event KeyPressed LETTER_B {}" +
+             "      Event KeyReleased LETTER_B {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence3 {" +
+             "    TextInputEvent TextInput C {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_C {}" +
+             "      Event KeyReleased LETTER_C {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element2);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_D), element2);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_D), element2);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_E), element2);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_E), element2);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_F), element2);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_F), element2);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element2);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  Sequence sequence1 {" +
+             "    TextInputEvent TextInput a {" +
+             "      Event KeyPressed LETTER_A {}" +
+             "      Event KeyReleased LETTER_A {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence2 {" +
+             "    TextInputEvent TextInput b {" +
+             "      Event KeyPressed LETTER_B {}" +
+             "      Event KeyReleased LETTER_B {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence3 {" +
+             "    TextInputEvent TextInput C {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_C {}" +
+             "      Event KeyReleased LETTER_C {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence4 {" +
+             "    TextInputEvent TextInput DEF {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_D {}" +
+             "      Event KeyReleased LETTER_D {}" +
+             "      Event KeyPressed LETTER_E {}" +
+             "      Event KeyReleased LETTER_E {}" +
+             "      Event KeyPressed LETTER_F {}" +
+             "      Event KeyReleased LETTER_F {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_G), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_G), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        simulateEvent(new KeyReleased(VirtualKey.SHIFT), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  Sequence sequence1 {" +
+             "    TextInputEvent TextInput a {" +
+             "      Event KeyPressed LETTER_A {}" +
+             "      Event KeyReleased LETTER_A {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence2 {" +
+             "    TextInputEvent TextInput b {" +
+             "      Event KeyPressed LETTER_B {}" +
+             "      Event KeyReleased LETTER_B {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence3 {" +
+             "    TextInputEvent TextInput C {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_C {}" +
+             "      Event KeyReleased LETTER_C {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence4 {" +
+             "    TextInputEvent TextInput DEF {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_D {}" +
+             "      Event KeyReleased LETTER_D {}" +
+             "      Event KeyPressed LETTER_E {}" +
+             "      Event KeyReleased LETTER_E {}" +
+             "      Event KeyPressed LETTER_F {}" +
+             "      Event KeyReleased LETTER_F {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "  Sequence sequence5 {" +
+             "    TextInputEvent TextInput g {" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed SHIFT {}" +
+             "      Event KeyPressed LETTER_G {}" +
+             "      Event KeyReleased LETTER_G {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "      Event KeyReleased SHIFT {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree());
+
+    }
+
+    /**
+     *
+     */
+    @Test
+    public void testUsageOfBackspace() {
+        IGUIElement element1 = new DummyTextField("elem1");
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_A), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_A), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_B), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_B), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_C), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_D), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_D), element1);
+        simulateEvent(new KeyPressed(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyReleased(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_E), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_E), element1);
+        simulateEvent(new KeyPressed(VirtualKey.LETTER_F), element1);
+        simulateEvent(new KeyReleased(VirtualKey.LETTER_F), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput abcef {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "    Event KeyPressed LETTER_C {}" +
+             "    Event KeyReleased LETTER_C {}" +
+             "    Event KeyPressed LETTER_D {}" +
+             "    Event KeyReleased LETTER_D {}" +
+             "    Event KeyPressed BACK_SPACE {}" +
+             "    Event KeyReleased BACK_SPACE {}" +
+             "    Event KeyPressed LETTER_E {}" +
+             "    Event KeyReleased LETTER_E {}" +
+             "    Event KeyPressed LETTER_F {}" +
+             "    Event KeyReleased LETTER_F {}" +
+             "  }" +
+             "}", getTaskTree());
+
+        simulateEvent(new KeyPressed(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyReleased(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyPressed(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyReleased(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyPressed(VirtualKey.BACK_SPACE), element1);
+        simulateEvent(new KeyReleased(VirtualKey.BACK_SPACE), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence0 {" +
+             "  TextInputEvent TextInput ab {" +
+             "    Event KeyPressed LETTER_A {}" +
+             "    Event KeyReleased LETTER_A {}" +
+             "    Event KeyPressed LETTER_B {}" +
+             "    Event KeyReleased LETTER_B {}" +
+             "    Event KeyPressed LETTER_C {}" +
+             "    Event KeyReleased LETTER_C {}" +
+             "    Event KeyPressed LETTER_D {}" +
+             "    Event KeyReleased LETTER_D {}" +
+             "    Event KeyPressed BACK_SPACE {}" +
+             "    Event KeyReleased BACK_SPACE {}" +
+             "    Event KeyPressed LETTER_E {}" +
+             "    Event KeyReleased LETTER_E {}" +
+             "    Event KeyPressed LETTER_F {}" +
+             "    Event KeyReleased LETTER_F {}" +
+             "    Event KeyPressed BACK_SPACE {}" +
+             "    Event KeyReleased BACK_SPACE {}" +
+             "    Event KeyPressed BACK_SPACE {}" +
+             "    Event KeyReleased BACK_SPACE {}" +
+             "    Event KeyPressed BACK_SPACE {}" +
+             "    Event KeyReleased BACK_SPACE {}" +
+             "  }" +
+             "}", getTaskTree());
+
+    }
+
+    /**
+     *
+     */
+    private static class DummyTextField extends DummyGUIElement implements ITextField {
+
+        /**  */
+        private static final long serialVersionUID = 1L;
+
+        /**
+         * TODO: comment
+         * 
+         * @param name
+         */
+        public DummyTextField(String name) {
+            super(name);
+        }
+
+    }
 
 }
